;
; BGM炷
;
; ݒFEXEC BGM_SET
; BGM~FEXEC BGM_STOP
; BGMĐFEXEC BGM_START
;
;

	relaxed on

TINT_VEC:	equ	$e606
TINT_ADD:	equ	$03ef
BGM_SETMAIN:	equ	$7000
BGM_INTMAIN:	equ	$7003
RPORT60:	equ	$e6a7
RPORT62:	equ	$e6a9
WPORT6A:	equ	$e6b1


	org	$df00

	jp	BGM_INIT	; $DF00
	jp	BGM_SET		; $DF03
	jp	BGM_START	; $DF06
	jp	BGM_STOP	; $DF09

P_FLAG:	db	$00		; $DF0C


BGM_INIT:
	di

	ld	a,$24
	out	($6a),a
	ld	a,$26
	out	($6b),a		; 0x4000-0x7FFF݂̏ORAM

	ld	de,$7000
	ld	hl,$f000
	ld	bc,$1000
	ldir

	ld	hl,WPORT6A
	ld	a,(hl)
	out	($6a),a
	inc	hl
	ld	a,(hl)
	out	($6b),a		; 0x4000-0x7FFF݂̏ɖ߂

	xor	a
	ld	(P_FLAG),a
	ld	hl,BGM_MAIN
	ld	(TINT_VEC),hl
	ei
	ret

BGM_START:
	ld	a,$01
	ld	(P_FLAG),a
	ret

BGM_STOP:
	di
	xor	a
	ld	(P_FLAG),a

	ld	a,$28
	ld	e,$00
	call	MOUTOPN		; CH0fBZ[u
	ld	a,$28
	ld	e,$01
	call	MOUTOPN		; CH1fBZ[u
	ld	a,$28
	ld	e,$02
	call	MOUTOPN		; CH2fBZ[u

	ld	a,$07
	ld	e,$bf
	call	MOUTOPN		; CH3,4,5fBZ[u

	ei
	ret

BGM_SET:
	di

	ld	a,$24
	out	($62),a
	out	($6a),a
	ld	a,$26
	out	($63),a
	out	($6b),a		; 0x4000-0x7FFF̓ǂݏORAM

	call	BGM_SETMAIN

	ld	hl,RPORT62
	ld	a,(hl)
	out	($62),a
	inc	hl
	ld	a,(hl)
	out	($63),a		; 0x4000-0x7FFF̓ǂݏoɖ߂
	ld	hl,WPORT6A
	ld	a,(hl)
	out	($6a),a
	inc	hl
	ld	a,(hl)
	out	($6b),a		; 0x4000-0x7FFF݂̏ɖ߂

	ei
	ret



BGM_MAIN:
	push	af
	push	bc
	push	de
	push	hl
	push	ix

	ld	a,$24
	out	($62),a
	out	($6a),a
	ld	a,$26
	out	($63),a
	out	($6b),a		; 0x4000-0x7FFF̓ǂݏORAM

	call	BGM_INTMAIN

	ld	hl,RPORT62
	ld	a,(hl)
	out	($62),a
	inc	hl
	ld	a,(hl)
	out	($63),a		; 0x4000-0x7FFF̓ǂݏoɖ߂
	ld	hl,WPORT6A
	ld	a,(hl)
	out	($6a),a
	inc	hl
	ld	a,(hl)
	out	($6b),a		; 0x4000-0x7FFF݂̏ɖ߂

	pop	ix
	pop	hl
	pop	de
	pop	bc
	pop	af
	jp	TINT_ADD


;
; OPÑ|[gAregEreg̓eo͂
;
MOUTOPN:
	push	af
.loop:	in	a,($a3)
	rlca
	jr	c,.loop
	pop	af
	out	($a0),a
	ld	a,e		; ԑ҂iKvHj
	ld	a,e		; ԑ҂iKvHj
	ld	a,e
	out	($a1),a
	ret

	org	$dffb
	db	$00

end
